structure Step :>
sig
    datatype result =
        Done
      | Stepped of Syntax.memory * Syntax.exp
      | Loops

    (*
    Given |-_Sigma mu : Sigma and |-_Sigma e : tau, return
      Done iff e is a value
      Loops iff {{mu || e}} loops by accessing a black hole
      Stepped (mu',e') iff {e || mu} |-> {e' || mu'} 
    *)
    val progress : Syntax.memory * Syntax.exp -> result
        
end = 
struct

    open Syntax

    datatype result =
        Done
      | Stepped of memory * exp
      | Loops
        
    fun progress (m : memory, e : exp) : result = raise Fail "unimplemented"

end

